
from Mailman.Logging.Syslog import syslog
from Mailman import MemberAdaptor
import mm_cfg
import time
import pickle
from Errors import *

DEBUG = False

class FileMemberships(MemberAdaptor.MemberAdaptor):
	def __init__(self, mlist, filename):
		self.__mlist = mlist
		self.__mlist.bounce_processing = False
		with open(filename) as f:
			# LCE: lower case email. CPE: case preserved email
			# load a list of {LCE -> [name, CPE]}
			self.members = pickle.load(f)
	
	def getMembers(self):
		return self.members.keys()
	
	def getRegularMemberKeys(self):
		return self.getMembers()
	
	def getDigestMemberKeys(self):
		return []
	
	def isMember(self, member):
		return self.members.has_key(member.lower())
	
	def getMemberKey(self, member):
		if not self.isMember(member): raise NotAMemberError
		return member
	
	def getMemberCPAddress(self, member):
		if not self.isMember(member): raise NotAMemberError
		return self.members[member.lower()][1]
	
	def getMemberCPAddresses(self, members):
		return [self.getMemberCPAddress(member) for member in members]

	def authenticateMember(self, member, response):
		raise NotImplementedError
	
	def getMemberPassword(self, member):
		raise NotImplementedError
	
	def getMemberLanguage(self, member):
		return self.__mlist.preferred_language
	
	def getMemberOption(self, member, flag):
		if not self.isMember(member): raise NotAMemberError
		if flag == mm_cfg.Moderate:
			return self.__mlist.default_member_moderation
			return bool(mm_cfg.DEFAULT_NEW_MEMBER_OPTIONS & flag)
	
	def getMemberName(self, member):
		if not self.isMember(member): raise NotAMemberError
		return self.members[member.lower()][0]
	
	def getMemberTopics(self, member):
		if not self.isMember(member): raise NotAMemberError
		return [topic[0] for topic in self.__mlist.topics]
	
	def getDeliveryStatus(self, member):
		if not self.isMember(member): raise NotAMemberError
		return MemberAdaptor.ENABLED
	
	def getDeliveryStatusChangeTime(self, member):
		if not self.isMember(member): raise NotAMemberError
		return 0
	
	def getDeliveryStatusMembers(self, status=(
			MemberAdaptor.UNKNOWN,
			MemberAdaptor.BYUSER,
			MemberAdaptor.BYADMIN,
			MemberAdaptor.BYBOUNCE)):
		return [member for member in self.getMembers() if self.getDeliveryStatus(member) in status]
	
	def getBouncingMembers(self):
		return []
	
	def getBounceInfo(self, member):
		if not self.isMember(member): raise NotAMemberError
		return None

