#!/usr/bin/python

import LdapSync

LdapSync.ldapsync(
#LDAP-server
uri = "ldap://example.com"

#if users also have a uid, the mailing list entries will be done with <uid>@<suffix>,
#and these aliases will be resolved in a separate aliases file
, suffix="example.com"

#if a list is defined in LDAP, but not yet configured, it will be created with
#postmaster@<suffix> as administrator and with <newlistpw> as password.
, newlistpw="test"

#base for LDAP-searches
, base="dc=example,dc=com"

#<oulists> defines the organizational unit where lists are defined, and similar for <oupeople>.
#They have default values
#, oulists = "ou=lists",
#, oupeople = "ou=people",

#meta-list name for all users that also have a uid. Will be ignored if None (default).
#, userslist = None

#If the server is set up for ldaps, you might want to set cacertfile
#, cacertfile = None

#file where the uid-aliases are put
#, uidaliases = "/etc/postfix/uid-aliases"

# file that gets populated with mailman's genaliases
#, mailaliases = "/etc/mailman/aliases"

# directory where the mailing lists reside. The default value is from debian
#, path2lists = "/var/lib/mailman/lists"

# path of genaliases. Also from debian
#, genaliases = "/usr/lib/mailman/bin/genaliases"
)
